/*
 * VMGDebugGridFragmentController.hpp
 *
 *  Created on: Aug 27, 2012
 *      Author: heber
 */

#ifndef VMGDEBUGGRIDFRAGMENTCONTROLLER_HPP_
#define VMGDEBUGGRIDFRAGMENTCONTROLLER_HPP_


// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "Fragmentation/Automation/SpecificFragmentController.hpp"

#include <map>
#include <string>
#include <vector>

#include "JobMarket/types.hpp"

#include "Fragmentation/Summation/SetValues/Fragment.hpp"
#include "Fragmentation/Summation/SetValues/SamplingGrid.hpp"
#include "Fragmentation/Summation/Containers/MPQCData.hpp"
#include "Fragmentation/Summation/Containers/VMGData.hpp"

/** This class uses SpecificFragmentController with functions to add specificly
 * VMGJobs.
 */
class VMGDebugGridFragmentController : public SpecificFragmentController
{
public:
  VMGDebugGridFragmentController(boost::asio::io_service &io_service) :
    SpecificFragmentController(io_service)
  {}
  virtual ~VMGDebugGridFragmentController()
  {}

  bool createDebugJobs(
      const std::vector<SamplingGrid> &full_sampled_grid,
      const bool _OpenBoundaryConditions = false);

  void waitforResults(const size_t NoExpectedResults)
  { results.waitforResults(NoExpectedResults, io_service, *this); }

  // there are no results but server has empty string nonetheless
  void getResults(std::map<JobId_t, std::string> &fragmentData) {
    fragmentData = results.IdData;
    results.clear();
  }

private:
  //!> type-specific result container
  SpecificFragmentController::ResultContainer<std::string> results;
};


#endif /* VMGDEBUGGRIDFRAGMENTCONTROLLER_HPP_ */
